resources:
  # Optional; if left out, automatically pick the cheapest cloud.
  cloud: aws
  # 1x NVIDIA V100 GPU
  #accelerators: V100:1
  image_id:
      us-west-2: ami-0604d81f2fd264c7b
      #us-west-2: ami-0141db48a2230e8e6
# Working directory (optional) containing the project codebase.
# Its contents are synced to ~/sky_workdir/ on the cluster.
  # disk_size: 30
  instance_type: g4dn.xlarge
workdir: .

# Typical use: pip install -r requirements.txt
# Invoked under the workdir (i.e., can use its files).
setup: |
  echo "Running setup."
  sudo yum install rsync -y
  sudo yum install gcc -y
  sudo dnf install -y kernel-devel-$(uname -r) kernel-headers-$(uname -r) kernel-modules-extra-$(uname -r)
  sudo dnf config-manager -y  --add-repo https://developer.download.nvidia.com/compute/cuda/repos/amzn2023/x86_64/cuda-amzn2023.repo
  sudo dnf module install -y nvidia-driver:latest-dkms
  sudo mkfs -t xfs /dev/nvme1n1
  mkdir -p /home/ubuntu/compress
  sudo mount /dev/nvme1n1 /home/ubuntu/compress
  sudo chown ubuntu:ubuntu /home/ubuntu/compress
  mv /home/ubuntu/miniconda3 /home/ubuntu/compress/miniconda3
  ln -s /home/ubuntu/compress/miniconda3 /home/ubuntu/miniconda3
  conda create -p /home/ubuntu/compress/envs/compress -y  python=3.8
  conda activate /home/ubuntu/compress/envs/compress
  conda install pytorch torchvision torchaudio pytorch-cuda=12.1 -c pytorch -c nvidia -y
  #conda install -c pytorch -y pytorch torchvision
  conda install matplotlib -y
  pip cache purge
  pip install pytorch-msssim compressai nvidia-dali-cuda120 --no-cache-dir
  pip cache purge

  [ "$INPUT" == "" ] && export INPUT=SrTiOGe
  aws s3 cp s3://nextflow-bucket-s3/$INPUT/ . --recursive --include "${INPUT}*"
  mkdir image_to_compress
  mv ${INPUT}* image_to_compress
  wget 'https://gitlab.com/perflab-exact/chess/autobahn-em/-/raw/main/modules/compress/ressource/compressGPU.py?ref_type=heads&inline=false' -O compressGPU.py
  wget 'https://gitlab.com/perflab-exact/chess/autobahn-em/-/raw/main/modules/compress/ressource/gpulz.so?ref_type=heads&inline=false' -O gpulz.so
  mkdir decompress_images

# Typical use: make use of resources, such as running training.
# Invoked under the workdir (i.e., can use its files).
run: |
  echo "Hello, Compress!"
  conda activate /home/ubuntu/compress/envs/compress
  python compressGPU.py
  aws s3 cp  decompress_images/ s3://nextflow-bucket-s3/${INPUT}_comp/ --recursive
  export done=1
  export comp_name=${INPUT}_comp
